Index: kern/init_main.c
===================================================================
RCS file: /cvs/src/sys/kern/init_main.c,v
retrieving revision 1.144
diff -u -r1.144 init_main.c
--- kern/init_main.c	10 Sep 2007 18:49:45 -0000	1.144
+++ kern/init_main.c	25 Sep 2007 09:54:07 -0000
@@ -327,7 +327,9 @@
 	(void)chgproccnt(0, 1);
 
 	/* Initialize run queues */
-	rqinit();
+	sched_init_runqueues();
+	sleep_queue_init();
+	sched_init_cpu(curcpu());
 
 	/* Initialize work queues */
 	workq_init();
Index: kern/kern_clock.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_clock.c,v
retrieving revision 1.64
diff -u -r1.64 kern_clock.c
--- kern/kern_clock.c	16 May 2007 17:27:30 -0000	1.64
+++ kern/kern_clock.c	25 Sep 2007 09:54:07 -0000
@@ -546,7 +546,7 @@
 			if (p != NULL)
 				p->p_iticks++;
 			spc->spc_cp_time[CP_INTR]++;
-		} else if (p != NULL) {
+		} else if (p != NULL && p != spc->spc_idleproc) {
 			p->p_sticks++;
 			spc->spc_cp_time[CP_SYS]++;
 		} else
Index: kern/kern_exit.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_exit.c,v
retrieving revision 1.71
diff -u -r1.71 kern_exit.c
--- kern/kern_exit.c	12 Apr 2007 22:14:15 -0000	1.71
+++ kern/kern_exit.c	25 Sep 2007 09:54:08 -0000
@@ -315,16 +315,8 @@
 	sigactsfree(p);
 
 	/*
-	 * Clear curproc after we've done all operations
-	 * that could block, and before tearing down the rest
-	 * of the process state that might be used from clock, etc.
-	 * Also, can't clear curproc while we're still runnable,
-	 * as we're not on a run queue (we are current, just not
-	 * a proper proc any longer!).
-	 *
-	 * Other substructures are freed from wait().
+	 * Other substructures are freed from reaper and wait().
 	 */
-	curproc = NULL;
 
 	/*
 	 * If emulation has process exit hook, call it now.
@@ -373,15 +365,11 @@
 void
 exit2(struct proc *p)
 {
-	int s;
-
 	mtx_enter(&deadproc_mutex);
 	LIST_INSERT_HEAD(&deadproc, p, p_hash);
 	mtx_leave(&deadproc_mutex);
 
 	wakeup(&deadproc);
-
-	SCHED_LOCK(s);
 }
 
 /*
@@ -395,6 +383,8 @@
 	struct proc *p;
 
 	KERNEL_PROC_UNLOCK(curproc);
+
+	SCHED_ASSERT_UNLOCKED();
 
 	for (;;) {
 		mtx_enter(&deadproc_mutex);
Index: kern/kern_fork.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_fork.c,v
retrieving revision 1.92
diff -u -r1.92 kern_fork.c
--- kern/kern_fork.c	25 Jul 2007 23:11:52 -0000	1.92
+++ kern/kern_fork.c	25 Sep 2007 09:54:08 -0000
@@ -224,7 +224,6 @@
 
 	p2->p_stat = SIDL;			/* protect against others */
 	p2->p_exitsig = exitsig;
-	p2->p_forw = p2->p_back = NULL;
 
 #ifdef RTHREADS
 	if (flags & FORK_THREAD) {
@@ -501,7 +500,12 @@
 
 	p = curproc;
 
+	SCHED_ASSERT_LOCKED();
+	__mp_unlock(&sched_lock);
+	spl0();
 	SCHED_ASSERT_UNLOCKED();
+	KASSERT(__mp_lock_held(&kernel_lock) == 0);
+
 	KERNEL_PROC_LOCK(p);
 }
 #endif
Index: kern/kern_proc.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_proc.c,v
retrieving revision 1.35
diff -u -r1.35 kern_proc.c
--- kern/kern_proc.c	7 Sep 2007 15:00:20 -0000	1.35
+++ kern/kern_proc.c	25 Sep 2007 09:54:08 -0000
@@ -377,8 +377,8 @@
 	    p->p_comm, p->p_pid, pst, p->p_flag, P_BITS);
 	(*pr)("    pri=%u, usrpri=%u, nice=%d\n",
 	    p->p_priority, p->p_usrpri, p->p_nice);
-	(*pr)("    forw=%p, back=%p, list=%p,%p\n",
-	    p->p_forw, p->p_back, p->p_list.le_next, p->p_list.le_prev);
+	(*pr)("    forw=%p, list=%p,%p\n",
+	    TAILQ_NEXT(p, p_runq), p->p_list.le_next, p->p_list.le_prev);
 	(*pr)("    user=%p, vmspace=%p\n",
 	    p->p_addr, p->p_vmspace);
 	(*pr)("    estcpu=%u, cpticks=%d, pctcpu=%u.%u%, swtime=%u\n",
Index: kern/kern_sched.c
===================================================================
RCS file: kern/kern_sched.c
diff -N kern/kern_sched.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ kern/kern_sched.c	25 Sep 2007 09:54:08 -0000
@@ -0,0 +1,242 @@
+/*	$OpenBSD$	*/
+/*
+ * Copyright (c) 2007 Artur Grabowski <art@openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include <sys/param.h>
+
+#include <sys/sched.h>
+#include <sys/proc.h>
+#include <sys/kthread.h>
+#include <sys/systm.h>
+#include <sys/resourcevar.h>
+#include <sys/signalvar.h>
+#include <sys/mutex.h>
+
+#include <uvm/uvm_extern.h>
+
+struct proc *sched_chooseproc(void);
+void sched_kthreads_create(void *);
+void sched_idle(void *);
+
+/*
+ * A few notes about cpu_switchto that is implemented in MD code.
+ *
+ * cpu_switchto takes two arguments, the old proc and the proc
+ * it should switch to. The new proc will never be NULL, so we always have
+ * a saved state that we need to switch to. The old proc however can
+ * be NULL if the process is exiting. NULL for the old proc simply
+ * means "don't bother saving old state".
+ *
+ * cpu_switchto is supposed to atomically load the new state of the process
+ * including the pcb, pmap and setting curproc, the p_cpu pointer in the
+ * proc and p_stat to SONPROC. Atomically with respect to interrupts, other
+ * cpus in the system must not depend on this state being consistent.
+ * Therefore no locking is necessary in cpu_switchto other than blocking
+ * interrupts during the context switch.
+ */
+
+/*
+ * sched_init_cpu is called from main() for the boot cpu, then it's the
+ * responsibility of the MD code to call it for all other cpus.
+ */
+void
+sched_init_cpu(struct cpu_info *ci)
+{
+	struct schedstate_percpu *spc = &ci->ci_schedstate;
+
+	spc->spc_idleproc = NULL;
+
+	kthread_create_deferred(sched_kthreads_create, ci);
+
+	LIST_INIT(&spc->spc_deadproc);
+}
+
+void
+sched_kthreads_create(void *v)
+{
+	struct cpu_info *ci = v;
+	struct schedstate_percpu *spc = &ci->ci_schedstate;
+	static int num;
+
+	if (kthread_create(sched_idle, ci, &spc->spc_idleproc, "idle%d", num))
+		panic("fork idle");
+
+	num++;
+}
+
+void
+sched_idle(void *v)
+{
+	struct proc *p = curproc;
+	struct cpu_info *ci = v;
+	int s;
+
+	KERNEL_PROC_UNLOCK(p);
+
+	/*
+	 * First time we enter here, we're not supposed to idle,
+	 * just go away for a while.
+	 */
+	SCHED_LOCK(s);
+	p->p_stat = SSLEEP;
+	mi_switch();
+	SCHED_UNLOCK(s);
+
+	while (1) {
+		KASSERT(ci == curcpu());
+		KASSERT(curproc == ci->ci_schedstate.spc_idleproc);
+
+		while (!sched_is_idle()) {
+			struct schedstate_percpu *spc = &ci->ci_schedstate;
+			struct proc *dead;
+
+			SCHED_LOCK(s);
+			p->p_stat = SSLEEP;
+			mi_switch();
+			SCHED_UNLOCK(s);
+
+			while ((dead = LIST_FIRST(&spc->spc_deadproc))) {
+				LIST_REMOVE(dead, p_hash);
+				exit2(dead);
+			}
+		}
+
+		cpu_idle_enter();
+		while (sched_is_idle())
+			cpu_idle_cycle();
+		cpu_idle_leave();
+	}
+}
+
+/*
+ * To free our address space we have to jump through a few hoops.
+ * The freeing is done by the reaper, but until we have one reaper
+ * per cpu, we have no way of putting this proc on the deadproc list
+ * and waking up the reaper without risking having our address space and
+ * stack torn from under us before we manage to switch to another proc.
+ * Therefore we have a per-cpu list of dead processes where we put this
+ * proc and have idle clean up that list and move it to the reaper list.
+ * All this will be unnecessary once we can bind the reaper this cpu
+ * and not risk having it switch to another in case it sleeps.
+ */
+void
+sched_exit(struct proc *p)
+{
+	struct schedstate_percpu *spc = &curcpu()->ci_schedstate;
+	struct timeval tv;
+	struct proc *idle;
+	int s;
+
+	microuptime(&tv);
+	timersub(&tv, &spc->spc_runtime, &tv);
+	timeradd(&p->p_rtime, &tv, &p->p_rtime);
+
+	LIST_INSERT_HEAD(&spc->spc_deadproc, p, p_hash);
+
+#ifdef MULTIPROCESSOR
+	KASSERT(__mp_lock_held(&kernel_lock) == 0);
+#endif
+
+	SCHED_LOCK(s);
+	idle = spc->spc_idleproc;
+	idle->p_stat = SRUN;
+	cpu_switchto(NULL, idle);
+}
+
+/*
+ * Run queue management.
+ *
+ * The run queue management is just like before, except that it's with
+ * a bit more modern queue handling.
+ */
+
+TAILQ_HEAD(prochead, proc) sched_qs[NQS];
+volatile int sched_whichqs;
+
+void
+sched_init_runqueues(void)
+{
+	int i;
+
+	for (i = 0; i < NQS; i++)
+		TAILQ_INIT(&sched_qs[i]);
+
+#ifdef MULTIPROCESSOR
+	SIMPLE_LOCK_INIT(&sched_lock);
+#endif
+}
+
+void
+setrunqueue(struct proc *p)
+{
+	int queue = p->p_priority >> 2;
+
+	SCHED_ASSERT_LOCKED();
+
+	TAILQ_INSERT_TAIL(&sched_qs[queue], p, p_runq);
+	sched_whichqs |= (1 << queue);
+}
+
+void
+remrunqueue(struct proc *p)
+{
+	int queue = p->p_priority >> 2;
+
+	SCHED_ASSERT_LOCKED();
+
+	TAILQ_REMOVE(&sched_qs[queue], p, p_runq);
+	if (TAILQ_EMPTY(&sched_qs[queue]))
+		sched_whichqs &= ~(1 << queue);
+}
+
+struct proc *
+sched_chooseproc(void)
+{
+	struct proc *p;
+	int queue;
+
+	SCHED_ASSERT_LOCKED();
+
+again:
+	if (sched_whichqs == 0) {
+		p = curcpu()->ci_schedstate.spc_idleproc;
+		if (p == NULL) {
+                        int s;
+			/*
+			 * We get here if someone decides to switch during
+			 * boot before forking kthreads, bleh.
+			 * This is kind of like a stupid idle loop.
+			 */
+#ifdef MULTIPROCESSOR
+			__mp_unlock(&sched_lock);
+#endif
+			spl0();
+			delay(10);
+			SCHED_LOCK(s);
+			goto again;
+                }
+		KASSERT(p);
+		p->p_stat = SRUN;
+	} else {
+		queue = ffs(sched_whichqs) - 1;
+		p = TAILQ_FIRST(&sched_qs[queue]);
+		TAILQ_REMOVE(&sched_qs[queue], p, p_runq);
+		if (TAILQ_EMPTY(&sched_qs[queue]))
+			sched_whichqs &= ~(1 << queue);
+	}
+
+	return (p);	
+}
Index: kern/kern_synch.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_synch.c,v
retrieving revision 1.80
diff -u -r1.80 kern_synch.c
--- kern/kern_synch.c	16 May 2007 17:27:30 -0000	1.80
+++ kern/kern_synch.c	25 Sep 2007 09:54:08 -0000
@@ -67,10 +67,17 @@
  */
 #define TABLESIZE	128
 #define LOOKUP(x)	(((long)(x) >> 8) & (TABLESIZE - 1))
-struct slpque {
-	struct proc *sq_head;
-	struct proc **sq_tailp;
-} slpque[TABLESIZE];
+TAILQ_HEAD(slpque,proc) slpque[TABLESIZE];
+
+void
+sleep_queue_init(void)
+{
+	int i;
+
+	for (i = 0; i < TABLESIZE; i++)
+		TAILQ_INIT(&slpque[i]);
+}
+
 
 /*
  * During autoconfiguration or after a panic, a sleep will simply
@@ -133,15 +140,12 @@
 sleep_setup(struct sleep_state *sls, void *ident, int prio, const char *wmesg)
 {
 	struct proc *p = curproc;
-	struct slpque *qp;
 
 #ifdef DIAGNOSTIC
 	if (ident == NULL)
 		panic("tsleep: no ident");
 	if (p->p_stat != SONPROC)
 		panic("tsleep: not SONPROC");
-	if (p->p_back != NULL)
-		panic("tsleep: p_back not NULL");
 #endif
 
 #ifdef KTRACE
@@ -159,12 +163,7 @@
 	p->p_wmesg = wmesg;
 	p->p_slptime = 0;
 	p->p_priority = prio & PRIMASK;
-	qp = &slpque[LOOKUP(ident)];
-	if (qp->sq_head == 0)
-		qp->sq_head = p;
-	else
-		*qp->sq_tailp = p;
-	*(qp->sq_tailp = &p->p_forw) = NULL;
+	TAILQ_INSERT_TAIL(&slpque[LOOKUP(ident)], p, p_runq);
 }
 
 void
@@ -179,11 +178,12 @@
 		mi_switch();
 	} else if (!do_sleep) {
 		unsleep(p);
+	}
+
 #ifdef DIAGNOSTIC
-		if (p->p_stat != SONPROC)
-			panic("sleep_finish !SONPROC");
+	if (p->p_stat != SONPROC)
+		panic("sleep_finish !SONPROC");
 #endif
-	}
 
 	p->p_cpu->ci_schedstate.spc_curpriority = p->p_usrpri;
 	SCHED_UNLOCK(sls->sls_s);
@@ -296,17 +296,9 @@
 void
 unsleep(struct proc *p)
 {
-	struct slpque *qp;
-	struct proc **hp;
-
 	if (p->p_wchan) {
-		hp = &(qp = &slpque[LOOKUP(p->p_wchan)])->sq_head;
-		while (*hp != p)
-			hp = &(*hp)->p_forw;
-		*hp = p->p_forw;
-		if (qp->sq_tailp == &p->p_forw)
-			qp->sq_tailp = hp;
-		p->p_wchan = 0;
+		TAILQ_REMOVE(&slpque[LOOKUP(p->p_wchan)], p, p_runq);
+		p->p_wchan = NULL;
 	}
 }
 
@@ -317,25 +309,22 @@
 wakeup_n(void *ident, int n)
 {
 	struct slpque *qp;
-	struct proc *p, **q;
+	struct proc *p;
+	struct proc *pnext;
 	int s;
 
 	SCHED_LOCK(s);
 	qp = &slpque[LOOKUP(ident)];
-restart:
-	for (q = &qp->sq_head; (p = *q) != NULL; ) {
+	for (p = TAILQ_FIRST(qp); p != NULL && n != 0; p = pnext) {
+		pnext = TAILQ_NEXT(p, p_runq);
 #ifdef DIAGNOSTIC
-		if (p->p_back)
-			panic("wakeup: p_back not NULL");
 		if (p->p_stat != SSLEEP && p->p_stat != SSTOP)
 			panic("wakeup: p_stat is %d", (int)p->p_stat);
 #endif
 		if (p->p_wchan == ident) {
 			--n;
 			p->p_wchan = 0;
-			*q = p->p_forw;
-			if (qp->sq_tailp == &p->p_forw)
-				qp->sq_tailp = q;
+			TAILQ_REMOVE(qp, p, p_runq);
 			if (p->p_stat == SSLEEP) {
 				/* OPTIMIZED EXPANSION OF setrunnable(p); */
 				if (p->p_slptime > 1)
@@ -357,13 +346,8 @@
 				need_resched(p->p_cpu);
 				/* END INLINE EXPANSION */
 
-				if (n != 0)
-					goto restart;
-				else
-					break;
 			}
-		} else
-			q = &p->p_forw;
+		}
 	}
 	SCHED_UNLOCK(s);
 }
Index: kern/kern_sysctl.c
===================================================================
RCS file: /cvs/src/sys/kern/kern_sysctl.c,v
retrieving revision 1.157
diff -u -r1.157 kern_sysctl.c
--- kern/kern_sysctl.c	7 Sep 2007 15:00:20 -0000	1.157
+++ kern/kern_sysctl.c	25 Sep 2007 09:54:10 -0000
@@ -1280,9 +1280,7 @@
 		ki->p_vm_tsize = vm->vm_tsize;
 		ki->p_vm_dsize = vm->vm_dused;
 		ki->p_vm_ssize = vm->vm_ssize;
-
-		ki->p_forw = PTRTOINT64(p->p_forw);
-		ki->p_back = PTRTOINT64(p->p_back);
+		ki->p_forw = ki->p_back = 0;
 		ki->p_addr = PTRTOINT64(p->p_addr);
 		ki->p_stat = p->p_stat;
 		ki->p_swtime = p->p_swtime;
Index: kern/sched_bsd.c
===================================================================
RCS file: /cvs/src/sys/kern/sched_bsd.c,v
retrieving revision 1.12
diff -u -r1.12 sched_bsd.c
--- kern/sched_bsd.c	18 May 2007 16:10:15 -0000	1.12
+++ kern/sched_bsd.c	25 Sep 2007 09:54:10 -0000
@@ -57,9 +57,6 @@
 int	lbolt;			/* once a second sleep address */
 int	rrticks_init;		/* # of hardclock ticks per roundrobin() */
 
-int whichqs;			/* Bit mask summary of non-empty Q's. */
-struct prochd qs[NQS];
-
 struct SIMPLELOCK sched_lock;
 
 void scheduler_start(void);
@@ -359,29 +356,26 @@
 	SCHED_UNLOCK(s);
 }
 
-
-/*
- * Must be called at splstatclock() or higher.
- */
 void
 mi_switch(void)
 {
-	struct proc *p = curproc;	/* XXX */
+	struct schedstate_percpu *spc = &curcpu()->ci_schedstate;
+	struct proc *p = curproc;
+	struct proc *nextproc;
 	struct rlimit *rlim;
 	struct timeval tv;
-#if defined(MULTIPROCESSOR)
+#ifdef MULTIPROCESSOR
 	int hold_count;
 	int sched_count;
 #endif
-	struct schedstate_percpu *spc = &p->p_cpu->ci_schedstate;
+
+	KASSERT(p->p_stat != SONPROC);
 
 	SCHED_ASSERT_LOCKED();
 
-#if defined(MULTIPROCESSOR)
+#ifdef MULTIPROCESSOR
 	/*
 	 * Release the kernel_lock, as we are about to yield the CPU.
-	 * The scheduler lock is still held until cpu_switch()
-	 * selects a new process and removes it from the run queue.
 	 */
 	sched_count = __mp_release_all_but_one(&sched_lock);
 	if (p->p_flag & P_BIGLOCK)
@@ -391,7 +385,6 @@
 	/*
 	 * Compute the amount of time during which the current
 	 * process was running, and add that to its total so far.
-	 * XXX - use microuptime here to avoid strangeness.
 	 */
 	microuptime(&tv);
 	if (timercmp(&tv, &spc->spc_runtime, <)) {
@@ -427,16 +420,27 @@
 	 */
 	spc->spc_schedflags &= ~SPCF_SWITCHCLEAR;
 
-	/*
-	 * Pick a new current process and record its start time.
-	 */
-	uvmexp.swtch++;
-	cpu_switch(p);
+	nextproc = sched_chooseproc();
+
+	if (p != nextproc) {
+		uvmexp.swtch++;
+		cpu_switchto(p, nextproc);
+	} else {
+		p->p_stat = SONPROC;
+	}
+
+	SCHED_ASSERT_LOCKED();
 
 	/*
-	 * Make sure that MD code released the scheduler lock before
-	 * resuming us.
+	 * To preserve lock ordering, we need to release the sched lock
+	 * and grab it after we grab the big lock.
+	 * In the future, when the sched lock isn't recursive, we'll
+	 * just release it here.
 	 */
+#ifdef MULTIPROCESSOR
+	__mp_unlock(&sched_lock);
+#endif
+
 	SCHED_ASSERT_UNLOCKED();
 
 	/*
@@ -444,11 +448,11 @@
 	 * be running on a new CPU now, so don't use the cache'd
 	 * schedstate_percpu pointer.
 	 */
-	KDASSERT(p->p_cpu != NULL);
-	KDASSERT(p->p_cpu == curcpu());
+	KASSERT(p->p_cpu == curcpu());
+
 	microuptime(&p->p_cpu->ci_schedstate.spc_runtime);
 
-#if defined(MULTIPROCESSOR)
+#ifdef MULTIPROCESSOR
 	/*
 	 * Reacquire the kernel_lock now.  We do this after we've
 	 * released the scheduler lock to avoid deadlock, and before
@@ -458,20 +462,6 @@
 		__mp_acquire_count(&kernel_lock, hold_count);
 	__mp_acquire_count(&sched_lock, sched_count + 1);
 #endif
-}
-
-/*
- * Initialize the (doubly-linked) run queues
- * to be empty.
- */
-void
-rqinit(void)
-{
-	int i;
-
-	for (i = 0; i < NQS; i++)
-		qs[i].ph_link = qs[i].ph_rlink = (struct proc *)&qs[i];
-	SIMPLE_LOCK_INIT(&sched_lock);
 }
 
 static __inline void
Index: sys/proc.h
===================================================================
RCS file: /cvs/src/sys/sys/proc.h,v
retrieving revision 1.100
diff -u -r1.100 proc.h
--- sys/proc.h	25 Jul 2007 23:11:53 -0000	1.100
+++ sys/proc.h	25 Sep 2007 09:54:11 -0000
@@ -148,8 +148,7 @@
 #endif
 
 struct proc {
-	struct	proc *p_forw;		/* Doubly-linked run/sleep queue. */
-	struct	proc *p_back;
+	TAILQ_ENTRY(proc) p_runq;
 	LIST_ENTRY(proc) p_list;	/* List of all processes. */
 
 	struct	process *p_p;		/* The process of this thread. */
@@ -401,14 +400,6 @@
 extern struct pool session_pool;	/* memory pool for sessions */
 extern struct pool pcred_pool;		/* memory pool for pcreds */
 
-#define	NQS	32			/* 32 run queues. */
-extern int whichqs;			/* Bit mask summary of non-empty Q's. */
-struct	prochd {
-	struct	proc *ph_link;		/* Linked list of running processes. */
-	struct	proc *ph_rlink;
-};
-extern struct prochd qs[NQS];
-
 struct simplelock;
 
 struct proc *pfind(pid_t);	/* Find process by id. */
@@ -423,17 +414,10 @@
 int	leavepgrp(struct proc *p);
 void	yield(void);
 void	preempt(struct proc *);
-void	mi_switch(void);
 void	pgdelete(struct pgrp *pgrp);
 void	procinit(void);
-#if !defined(remrunqueue)
-void	remrunqueue(struct proc *);
-#endif
 void	resetpriority(struct proc *);
 void	setrunnable(struct proc *);
-#if !defined(setrunqueue)
-void	setrunqueue(struct proc *);
-#endif
 void	unsleep(struct proc *);
 void    wakeup_n(void *chan, int);
 void    wakeup(void *chan);
@@ -441,17 +425,13 @@
 void	reaper(void);
 void	exit1(struct proc *, int, int);
 void	exit2(struct proc *);
+void	cpu_exit(struct proc *);
 int	fork1(struct proc *, int, int, void *, size_t, void (*)(void *),
 	    void *, register_t *, struct proc **);
-void	rqinit(void);
 int	groupmember(gid_t, struct ucred *);
-#if !defined(cpu_switch)
-void	cpu_switch(struct proc *);
-#endif
 #if !defined(cpu_wait)
 void	cpu_wait(struct proc *);
 #endif
-void	cpu_exit(struct proc *);
 
 void	child_return(void *);
 
@@ -471,6 +451,7 @@
 void	sleep_finish(struct sleep_state *, int);
 int	sleep_finish_timeout(struct sleep_state *);
 int	sleep_finish_signal(struct sleep_state *);
+void	sleep_queue_init(void);
 
 int	tsleep(void *, int, const char *, int);
 #define ltsleep(c, p, w, t, l) tsleep(c, p, w, t)
Index: sys/sched.h
===================================================================
RCS file: /cvs/src/sys/sys/sched.h,v
retrieving revision 1.16
diff -u -r1.16 sched.h
--- sys/sched.h	18 May 2007 14:41:55 -0000	1.16
+++ sys/sched.h	25 Sep 2007 09:54:11 -0000
@@ -105,6 +105,11 @@
 	int spc_rrticks;		/* ticks until roundrobin() */
 	int spc_pscnt;			/* prof/stat counter */
 	int spc_psdiv;			/* prof/stat divisor */	
+	struct proc *spc_idleproc;	/* idle proc for this cpu */
+#ifdef notyet
+	struct proc *spc_reaper;	/* dead proc reaper */
+#endif
+	LIST_HEAD(,proc) spc_deadproc;
 };
 
 #ifdef	_KERNEL
@@ -114,6 +119,8 @@
 #define SPCF_SHOULDYIELD        0x0002  /* process should yield the CPU */
 #define SPCF_SWITCHCLEAR        (SPCF_SEENRR|SPCF_SHOULDYIELD)
 
+
+#define	NQS	32			/* 32 run queues. */
 #define	PPQ	(128 / NQS)		/* priorities per queue */
 #define NICE_WEIGHT 2			/* priorities per nice level */
 #define	ESTCPULIM(e) min((e), NICE_WEIGHT * PRIO_MAX - PPQ)
@@ -126,7 +133,21 @@
 struct cpu_info;
 void roundrobin(struct cpu_info *);
 
-#define sched_is_idle() (whichqs == 0)
+void sched_init_cpu(struct cpu_info *);
+void sched_exit(struct proc *);
+void mi_switch(void);
+void cpu_switchto(struct proc *, struct proc *);
+struct proc *sched_chooseproc(void);
+void cpu_idle_enter(void);
+void cpu_idle_cycle(void);
+void cpu_idle_leave(void);
+
+extern volatile int sched_whichqs;
+#define sched_is_idle()	(sched_whichqs == 0)
+
+void sched_init_runqueues(void);
+void setrunqueue(struct proc *);
+void remrunqueue(struct proc *);
 
 /* Inherit the parent's scheduler history */
 #define scheduler_fork_hook(parent, child) do {				\
Index: uvm/uvm_meter.c
===================================================================
RCS file: /cvs/src/sys/uvm/uvm_meter.c,v
retrieving revision 1.22
diff -u -r1.22 uvm_meter.c
--- uvm/uvm_meter.c	14 Feb 2007 00:53:48 -0000	1.22
+++ uvm/uvm_meter.c	25 Sep 2007 09:54:11 -0000
@@ -109,6 +109,8 @@
 				continue;
 		/* FALLTHROUGH */
 		case SRUN:
+			if (p == p->p_cpu->ci_schedstate.spc_idleproc)
+				continue;
 		case SIDL:
 		case SONPROC:
 			nrun++;

